var functionsGlobals = {

    carga_paradas: false,
    fadeSpeed: "fast",


    getConfiguration: function() {
        /*if(localStorage.getItem("migracion_WS") != 1)
        {
        	localStorage.clear();
        	localStorage.setItem("migracion_WS", 1);
        }*/


        $.ajax({
                url: URL_CONFIGURATION + "/config.json",
                dataType: "json",
                cache: false,
                async: false
            }).done(function(json) {

                $.each(json, function(key, value) {
                    $.each(value, function(key, value) {
                        aConfig[key] = value;
                    });
                })
            })
            .error(function(xhRequest, textStatus, errorThrown) {
                functionsGlobals.getConfigurationLocal();
            });

    },

    getConfigurationLocal: function() {
        $.ajax({
                url: URL_CONFIGURATION_LOCAL + "/config.json",
                dataType: "json",
                cache: false,
                async: false
            }).done(function(json) {

                $.each(json, function(key, value) {
                    $.each(value, function(key, value) {
                        aConfig[key] = value;
                    });
                })
            })
            .error(function(xhRequest, textStatus, errorThrown) {
                functionsGlobals.hideLoading();
            });

    },

    loadLanguage: function() {
        language = localStorage.getItem("language");

        $.ajax({
                url: URL_CONFIGURATION + "/lang/" + language + ".json",
                dataType: "json",
                cache: false,
                async: false
            }).done(function(json) {
                gjson_lang = json;
            })
            .error(function(xhRequest, textStatus, errorThrown) {
                functionsGlobals.loadLanguageLocal();
            });
    },


    loadLanguageLocal: function() {
        language = localStorage.getItem("language");

        $.ajax({
                url: URL_CONFIGURATION_LOCAL + "/lang/" + language + ".json",
                dataType: "json",
                cache: false,
                async: false
            }).done(function(json) {
                gjson_lang = json;
            })
            .error(function(xhRequest, textStatus, errorThrown) {
                functionsGlobals.hideLoading();
            });
    },

    showLoading: function(p_msg_text, p_text_visible, p_text_only, p_html, p_theme) {
        $("body").addClass('ui-disabled');
        $(".ui-loader").css("display", "block");

        var str_msg_text = (typeof p_msg_text == "string") ? p_msg_text : ""; //$.mobile.loader.prototype.options.text;
        var b_text_visible = (typeof p_text_visible == "boolean") ? p_text_visible : false; //$.mobile.loader.prototype.options.textVisible;
        var b_text_only = (typeof p_text_only == "boolean") ? p_text_only : false;
        var str_html = (typeof p_msg_text == "string") ? p_html : "";
        var str_theme = (typeof p_msg_text == "string") ? p_theme : $.mobile.loader.prototype.options.theme;

        $.mobile.loading("show", {
            text: str_msg_text,
            textVisible: b_text_visible,
            textonly: b_text_only,
            theme: str_theme,
            html: str_html
        });

        $(".ui-loader").css("display", "block");
    },

    hideLoading: function() {
        $.mobile.loading("hide");
        $("body").removeClass('ui-disabled');
        $(".ui-loader").css("display", "none");
    },

    openSubmenu() {

        $(".panel_submenu").fadeIn(functionsGlobals.fadeSpeed);
        $(".menu_separator").fadeIn(functionsGlobals.fadeSpeed)
        localStorage.setItem('menuClosed', false);

    },

    closeSubmenu() {
        $(".panel_submenu").fadeOut(functionsGlobals.fadeSpeed)
        $(".menu_separator").fadeOut(functionsGlobals.fadeSpeed)
        localStorage.setItem('menuClosed', true);

    },

    createPanel: function($page) {

        $page.find(".menu_lateral").empty();
        //$page.find(".menu_lateral").append('<h1>Bilbobus</h1>');

        $page.find(".menu_lateral").append('<img src="img/panel/menu_logo.png"/ class = "panel_logo_image">');
        $page.find(".menu_lateral").append('<li id = selected_menu_1><a href="lines.html"><img src="img/panel/menu_lineas.png" class="panel-images">' + gjson_lang['panel_lineas'] + '</a></li>');
        $page.find(".menu_lateral").append('<li id = selected_menu_2><a href="NextToMe.html"><img src="img/panel/menu_paradas.png" class="panel-images">' + gjson_lang['panel_paradas'] + '</a></li>');
        $page.find(".menu_lateral").append('<li id = selected_menu_3><a href="favorites.html"><img src="img/panel/menu_favoritos.png" class="panel-images">' + gjson_lang['panel_favoritos'] + '</a></li>');
        $page.find(".menu_lateral").append('<li id = selected_menu_16><img src="img/panel/menu_avisos.png" class="panel-images"><a class ="link_notifications" href="notifications.html">' + gjson_lang['panel_push'] +
            '<span class="pending_notifications"></span></a></li>');
        $page.find(".menu_lateral").append('<li id = selected_menu_17><img src="img/panel/menu_twitter.png" class="panel-images"><a href="twitter.html">' + gjson_lang['panel_twitter'] + '</a></li>');
        $page.find(".menu_lateral").append('<li id = selected_menu_4><img src="img/panel/menu_informacion.png" class="panel-images"><a href="news.html">' + gjson_lang['panel_news'] + '</a></li>');
        $page.find(".menu_lateral").append('<li id = selected_menu_5><a href="rates.html"><img src="img/panel/menu_tarifas.png" class="panel-images">' + gjson_lang['panel_tarifas'] + '</a></li>');
        $page.find(".menu_lateral").append('<li id = selected_menu_6><img src="img/panel/menu_ciudadano.png" class="panel-images"><span>' + gjson_lang['panel_ciudadano'] + '</span></li>');
        $page.find(".menu_lateral").append('<li id = selected_menu_7 class="menu_separator"></li>');
        $page.find(".menu_lateral").append('<li id = selected_menu_8 class = "panel_submenu"><a href="lost.html">' + gjson_lang['panel_lost'] + '</a></li>');
        $page.find(".menu_lateral").append('<li id = selected_menu_9 class = "panel_submenu"><a href="suggestions.html">' + gjson_lang['panel_suggestions'] + '</a></li>');
        $page.find(".menu_lateral").append('<li id = selected_menu_10 class = "panel_submenu"><a href="language.html">' + gjson_lang['panel_language'] + '</a></li>');
        $page.find(".menu_lateral").append('<li id = selected_menu_11 class = "panel_submenu"><a href="rules.html">' + gjson_lang['panel_rules'] + '</a></li>');
        $page.find(".menu_lateral").append('<li id = selected_menu_12 class = "panel_submenu"><a href="about.html">' + gjson_lang['panel_about'] + '</a></li>');
        $page.find(".menu_lateral").append('<li id = selected_menu_13 class="menu_separator"></li>');
        $page.find(".menu_lateral").append('<li id = selected_menu_14><img src="img/panel/menu_ayuda.png" class="panel-images"><a href="help.html">' + gjson_lang['panel_ayuda'] + '</a></li>');
        $page.find(".menu_lateral").append('<li id = selected_menu_15><img src="img/panel/menu_apps.png" class="panel-images"><a href="apps.html">' + gjson_lang['panel_apps'] + '</a></li>');

        $page.find("#panel_Bilbobus").panel();

        var selected_menu = $page.attr("id");

        switch (selected_menu) {
            case 'page_lines':
                $page.find("#selected_menu_1").addClass("menu_selected");
                break;
            case 'page_nextToMe':
                $page.find("#selected_menu_2").addClass("menu_selected");
                break;
            case 'page_all_stops':
                $page.find("#selected_menu_2").addClass("menu_selected");
                break;
            case 'page_favorites':
                $page.find("#selected_menu_3").addClass("menu_selected");
                break;
            case 'page_favorites_lineas':
                $page.find("#selected_menu_3").addClass("menu_selected");
                break;
            case 'page_news':
                $page.find("#selected_menu_4").addClass("menu_selected");
                break;
            case 'page_rates':
                $page.find("#selected_menu_5").addClass("menu_selected");
                break;
            case 'page_twitter':
                $page.find("#selected_menu_17").addClass("menu_selected");
                break;
            case 'page_lost':
                $page.find("#selected_menu_8").addClass("menu_selected2");
                break;
            case 'page_suggestions':
                $page.find("#selected_menu_9").addClass("menu_selected2");
                break;
            case 'page_language':
                $page.find("#selected_menu_10").addClass("menu_selected2");
                break;
            case 'page_rules':
                $page.find("#selected_menu_11").addClass("menu_selected2");
                break;
            case 'page_about':
                $page.find("#selected_menu_12").addClass("menu_selected2");
                break;
            case 'page_help':
                $page.find("#selected_menu_14").addClass("menu_selected");
                break;
            case 'page_apps':
                $page.find("#selected_menu_15").addClass("menu_selected");
                break;
            case 'page_notifications':
                $page.find("#selected_menu_16").addClass("menu_selected");
                break;
        }

    },

    getLocation: function() {
        if (navigator.geolocation && gb_isCordovaLoaded)
            navigator.geolocation.getCurrentPosition(functionsGlobals.getPosition, functionsGlobals.getPositionDefault, { enableHighAccuracy: true, timeout: 5000, maximumAge: 3000 });
        else {
            sessionStorage.setItem("geolocation_OK", "false");
            console.log("Geolocation is not supported by this browser");
            functionsGlobals.getPositionDefault();
        }

    },

    getPosition: function(position) {
        sessionStorage.setItem("latitud", position.coords.latitude);
        sessionStorage.setItem("longitud", position.coords.longitude);
        sessionStorage.setItem("geolocation_OK", "true");
    },

    getPositionDefault: function() {
        // Default to Center of Bilbao, when no geolocation support
        sessionStorage.setItem("latitud", aConfig["default_lat"]);
        sessionStorage.setItem("longitud", aConfig["default_lng"]);
        sessionStorage.setItem("geolocation_OK", "false");
    },

    geolocation_OK: function() {
        if (sessionStorage.getItem("geolocation_OK") == "true")
            return true;
        else
            return false;
    },

    createOpenLayerPoint: function(uPoint, icon, scale, element) {
        var iconFeature = new ol.Feature({
            geometry: new ol.geom.Point(uPoint)
        });

        var iconStyle = new ol.style.Style({
            image: new ol.style.Icon(({
                anchorXUnits: 'fraction',
                anchorYUnits: 'fraction',
                src: icon,
                scale: scale
            }))
        });

        iconFeature.setStyle(iconStyle);

        var VectorSource = new ol.source.Vector({
            features: [iconFeature]
        });

        var Layer = new ol.layer.Vector({
            source: VectorSource,
            element: element
        });

        Layer.setZIndex(2);

        return Layer;
    },

    getRutaOL: function(linea, direction, object) {
        // PINTADO DE RECORRIDO
        var aux_aRoute = [];
        var route = [];
        var map = eval(object);

        connection.getResponse(aConfig["URL_RUTA_LINEA"] + linea + direction, "json")
            .done(function(data_response) {
                for (var x = 0, len = data_response.features.length; x < len; x++) {
                    aux_aRoute.push({
                        coordinates: []
                    });

                    for (var y = 0, len2 = data_response.features[x].geometry.coordinates.length; y < len2; y++)
                        for (var z = 0, len3 = data_response.features[x].geometry.coordinates[y].length; z < len3; z++) {
                            var point = functionsGlobals.cambiarCimubisaGoogle(data_response.features[x].geometry.coordinates[y][z][0], data_response.features[x].geometry.coordinates[y][z][1]);

                            aux_aRoute[x].coordinates.push({
                                lat: point.y,
                                lng: point.x
                            });
                        }
                }

                var color = functionsGlobals.getColorLine(linea);

                $.each(aux_aRoute, function(i, item) {
                    route.push(item.coordinates);
                });

                var vectorLine = new ol.source.Vector({});

                $.each(route, function(i, item) {
                    var points = [];

                    $.each(item, function(j, item2) {
                        points[j] = ol.proj.fromLonLat([eval(item2.lng), eval(item2.lat)]);
                        if (object == "pageTravelMap.$map")
                            map.getView().setCenter(points[j]);
                    });

                    var featureLine = new ol.Feature({
                        geometry: new ol.geom.LineString(points)
                    });

                    vectorLine.addFeature(featureLine);

                });

                var color = functionsGlobals.getColorLine(linea);

                var LinesLayer = new ol.layer.Vector({
                    source: vectorLine,
                    style: new ol.style.Style({
                        fill: new ol.style.Fill({ color: color, weight: 5 }),
                        stroke: new ol.style.Stroke({ color: color, width: 5 })
                    })
                });

                map.addLayer(LinesLayer);
                LinesLayer.setZIndex(0);

            });
    },

    getBusOL: function(linea, direction, object) {
        var aux_aBus = [];
        var map = eval(object);

        // PINTADO DE AUTOBUSES
        connection.getResponse(aConfig["URL_RUTA_AUTOBUSES"] + linea + direction + "&", "json")
            .done(function(data_response) {
                $.each(data_response.features, function(i, item) {
                    var point = functionsGlobals.cambiarCimubisaGoogle(item.geometry.coordinates[0], item.geometry.coordinates[1]);
                    var bPoint = ol.proj.fromLonLat([eval(point.x), eval(point.y)]);
                    var busesLayers = functionsGlobals.createOpenLayerPoint(bPoint, "img/map/stops/" + linea + ".png", ".8");

                    map.addLayer(busesLayers);
                    busesLayers.setZIndex(2);
                });
            });
    },

    getBusStopOL: function(linea, direction, object) {
        var map = eval(object);

        // PINTADO DE AUTOBUSES
        connection.getResponse(aConfig["URL_RUTA_PARADAS"] + linea + direction + "&", "json")
            .done(function(data_response) {
                $.each(data_response.features, function(i, item) {
                    var point = functionsGlobals.cambiarCimubisaGoogle(item.geometry.coordinates[0], item.geometry.coordinates[1]);
                    var bSPoint = ol.proj.fromLonLat([eval(point.x), eval(point.y)]);
                    var busStopLayers = functionsGlobals.createOpenLayerPoint(bSPoint, "img/map/stops/P" + linea + ".png", ".8");

                    map.addLayer(busStopLayers);
                    busStopLayers.setZIndex(1);
                });
            });
    },

    translatePage: function($page) {
        $page.find(":jqmData(t)").each(function() {
            var txt = $(this).attr("data-t");
            var params = $(this).attr("data-t-params");
            var translation = gjson_lang[txt];
            if (params) {
                translation = String.format(translation, params);
            }
            $(this).html(translation);
        });
    },

    // Changes XML to JSON
    xmlToJson: function(xml) {

        // Create the return object
        var obj = {};

        if (xml.nodeType == 1) { // element
            // do attributes
            if (xml.attributes.length > 0) {
                obj["@attributes"] = {};
                for (var j = 0; j < xml.attributes.length; j++) {
                    var attribute = xml.attributes.item(j);
                    obj["@attributes"][attribute.nodeName] = attribute.nodeValue;
                }
            }
        } else if (xml.nodeType == 3) { // text
            obj = xml.nodeValue;
        }

        // do children
        if (xml.hasChildNodes()) {
            for (var i = 0; i < xml.childNodes.length; i++) {
                var item = xml.childNodes.item(i);
                var nodeName = item.nodeName;
                if (typeof(obj[nodeName]) == "undefined") {
                    obj[nodeName] = xmlToJson(item);
                } else {
                    if (typeof(obj[nodeName].push) == "undefined") {
                        var old = obj[nodeName];
                        obj[nodeName] = [];
                        obj[nodeName].push(old);
                    }
                    obj[nodeName].push(xmlToJson(item));
                }
            }
        }
        return obj;
    },

    getURLParameter: function(name) {
        var value = (RegExp(name + '=' + '(.+?)(&|$)').exec(location.search) || [, null])[1];
        if (value) return decodeURI(value)
        return null;
    },

    comprobarDatos: function(data, id, sms) {

        if (data != "")
            return true;
        else {
            $(id).text(sms);
            functionsGlobals.hideLoading();
            return false;
        }
    },

    UTCDateFormat: function(date) {
        var utc = new Date(date.getTime() + date.getTimezoneOffset() * 60000)
        var utcdate = utc.getHours() + ':' + (utc.getMinutes() < 10 ? '0' : '') + utc.getMinutes();
        return utcdate;
    },

    getDateFormatted: function(daystamp) {
        daystamp = daystamp.replace(/-/g, '');

        var date = functionsGlobals.parseDateFromYYYYMMDD("" + daystamp);

        if (gjson_lang.lang != "eu")
            return date.getDate() + " " + gjson_lang["month_" + date.getMonth()] + " " + date.getFullYear();
        else
            return date.getFullYear() + "ko " + gjson_lang["month_" + date.getMonth()] + "ren " + date.getDate();

    },

    parseDateFromYYYYMMDD: function(str) {
        return new Date(str.substr(0, 4),
            str.substr(4, 2) - 1,
            str.substr(6, 2));
    },

    getScript: function(src) {
        if ($('script[src="' + src + '"]').length > 0) {
            return true;
        } else {
            return false;
        }
    },

    distanceBetweenPoint: function(lat1, lon1, lat2, lon2) {
        var deg2rad = 0.017453292519943295; // === Math.PI / 180
        var cos = Math.cos;
        lat1 *= deg2rad;
        lon1 *= deg2rad;
        lat2 *= deg2rad;
        lon2 *= deg2rad;
        var a = (
            (1 - cos(lat2 - lat1)) +
            (1 - cos(lon2 - lon1)) * cos(lat1) * cos(lat2)
        ) / 2;

        return Math.round((12742 * Math.asin(Math.sqrt(a))) * 1000); // Diameter of the earth in km (2 * 6371)
    },



    distanceStops: function(stop, lat2, lon2) {
        var aParadas = JSON.parse(localStorage.getItem("array_paradas"));

        $.each(aParadas, function(i, item) {
            if (item.id_parada == stop) {
                lat1 = item.latitud;
                lon1 = item.longitud;
            }

        });

        var deg2rad = 0.017453292519943295; // === Math.PI / 180
        var cos = Math.cos;
        lat1 *= deg2rad;
        lon1 *= deg2rad;
        lat2 *= deg2rad;
        lon2 *= deg2rad;
        var a = (
            (1 - cos(lat2 - lat1)) +
            (1 - cos(lon2 - lon1)) * cos(lat1) * cos(lat2)
        ) / 2;

        return Math.round((12742 * Math.asin(Math.sqrt(a))) * 1000); // Diameter of the earth in km (2 * 6371)
    },

    saveStops: function(data) {
        var aParadasINIT = new Array();

        if (data.numberOfFeatures == undefined) {
            functionsGlobals.showMessage(gjson_lang['error_ajax']);
            functionsGlobals.hideLoading();
            return false;
        }

        $.each(data.featureMembers.StopPoint, function(i, item) {

            var coords = item.projection.PointGeometry.geometry.Point.pos;
            var partsOfStr = coords.split(' ');
            var latitud = partsOfStr[1];
            var longitud = partsOfStr[0];

            aParadasINIT.push({
                id_parada: item.stopPointId.StopPointCode.identifier,
                id_parada_interno: i + 1,
                name_parada: item.stopPointName.PT_FreeText.textGroup.LocalisedCharacterString,
                latitud: latitud,
                longitud: longitud
            });

        });

        //var aParadasINIT = aParadasINIT.sort(function(a,b) { return a.id_parada - b.id_parada; } );

        aParadasINIT = aParadasINIT.sort(functionsGlobals.SortByparada);

        localStorage.setItem("array_paradasINIT", JSON.stringify(aParadasINIT));

        CallService(aConfig["gstr_webServiceURL"], createSoapRequestgetStopsPerLine(""), 'functionsGlobals.updateStops');

    },
    SortByLinea: function(a, b) {
        var aName = a.id_linea;
        var bName = b.id_linea;
        return ((aName < bName) ? -1 : ((aName > bName) ? 1 : 0));
    },

    SortByparada: function(a, b) {
        var aName = a.id_parada;
        var bName = b.id_parada;
        return ((aName < bName) ? -1 : ((aName > bName) ? 1 : 0));
    },

    SortByDistance: function(a, b) {
        var aName = a.distance;
        var bName = b.distance;
        return ((aName < bName) ? -1 : ((aName > bName) ? 1 : 0));
    },

    SortByArrivalTime: function(a, b) {
        var aName = a.arrival_time;
        var bName = b.arrival_time;
        return ((aName < bName) ? -1 : ((aName > bName) ? 1 : 0));
    },

    SortByOrden: function(a, b) {
        var aName = a.orden;
        var bName = b.orden;
        return ((aName < bName) ? -1 : ((aName > bName) ? 1 : 0));
    },

    SortByHours: function(a, b) {
        var aName = a.horas_salida;
        var bName = b.horas_salida;
        return ((aName < bName) ? -1 : ((aName > bName) ? 1 : 0));
    },

    deleteStops: function() {

        if (!localStorage.getItem("localUpdate")) {
            milisegundos = parseInt(35 * 24 * 60 * 60 * 1000);
            fecha = new Date();
            dia = fecha.getDate();
            mes = fecha.getMonth() + 1;
            anio = fecha.getYear();
            tiempo = fecha.getTime();
            total = fecha.setTime(parseInt(tiempo + milisegundos));
            localStorage.setItem("localUpdate", total);
        }



        milisegundos = parseInt(35 * 24 * 60 * 60 * 1000);
        fecha = new Date();
        dia = fecha.getDate() + 1;
        mes = fecha.getMonth() + 1;
        anio = fecha.getYear();
        tiempo = fecha.getTime();
        total2 = fecha.setTime(parseInt(tiempo + milisegundos));

        if (localStorage.getItem("array_lineas")) {
            var aLineas = JSON.parse(localStorage.getItem("array_lineas"));

            if (total2 - localStorage.getItem("localUpdate") > aConfig["update_rate"]) {
                localStorage.removeItem("array_lineas");
                localStorage.removeItem("array_paradas");

                for (var i = 1, len = (aLineas.length + 1) * 2; i < (aLineas.length + 1) * 2; i++) {
                    localStorage.removeItem("array_lineasParadas" + i);
                }

                localStorage.setItem("localUpdate", total2);
            }
        }
    },

    updateStops: function(data) {
        var aParadas = [];
        var aParadasAux = [];
        var aParadasINIT = JSON.parse(localStorage.getItem("array_paradasINIT"));

        $.each(aParadasINIT, function(i, item) {
            $.each(data.LISTA.DETALLE, function(j, item2)

                {


                    if (item.id_parada == item2.PARADAAUTOBUS) {
                        aParadas.push({
                            id_linea: item2.CODIGOLINEA,
                            id_parada: item.id_parada,
                            name_parada: item.name_parada,
                            id_parada_interno: item.id_parada_interno,
                            latitud: item.latitud,
                            longitud: item.longitud
                        });

                        aParadasAux[j] = item.id_parada;
                    }

                });
        });

        for (var i = 0; i < aParadas.length; i++) {
            for (var x = i + 1; x < aParadas.length; x++) {
                if (aParadas[x].id_parada == aParadas[i].id_parada && aParadas[x].id_linea == aParadas[i].id_linea) {
                    aParadas.splice(x, 1);
                    --x;
                }
            }
            // add
        }

        var aParadas = aParadas.sort(function(a, b) { return a.id_linea - b.id_linea; });

        localStorage.setItem("array_paradas", JSON.stringify(aParadas));
        localStorage.removeItem("array_paradasINIT");
        functionsGlobals.carga_paradas = true;
        functionsGlobals.hideLoading();
        eval(sessionStorage.getItem("activeFunction"));
    },


    isFavorite: function(stop) {
        var exist = false;
        var aFavorites = JSON.parse(localStorage.getItem("array_favorites"));

        if (aFavorites) {
            $.each(aFavorites, function(i, item) {
                if (item.id_parada == stop)
                    exist = true;
            });
        }

        return exist;
    },

    isFavoriteLine: function(linea) {
        var exist = false;
        var aFavorites = JSON.parse(localStorage.getItem("array_favorites_lineas"));

        if (aFavorites) {
            $.each(aFavorites, function(i, item) {
                if (item.id_linea == linea)
                    exist = true;
            });
        }

        return exist;
    },

    deleteSessionStorage: function() {
        sessionStorage.clear();
        functionsGlobals.getLocation();
    },

    getColorLine: function(line) {
        var aColor = JSON.parse(localStorage.getItem("colores_lineas")) || [];
        var color = "#000000";
        $.each(aColor, function(i, item) {
            if (item.id_linea == line) {
                color = item.color;
            }

        });

        return color;
    },

    saveLineColors: function(data) {
        var aColors = [];

        $.each(data.LISTA.DETALLE, function(j, item) {
            aColors.push({
                id_linea: item.CODIGOLINEA,
                color: "#" + item.RGB
            });
        });

        for (var i = 0; i < aColors.length; i++) {
            for (var x = i + 1; x < aColors.length; x++) {
                if (aColors[x].id_linea == aColors[i].id_linea) {
                    aColors.splice(x, 1);
                    --x;
                }
            }
        }

        localStorage.setItem("colores_lineas", JSON.stringify(aColors));
    },

    cambiarCimubisaGoogle: function(miX, miY) {
        //X = LONGITUD
        //Y = LATITUD
        var thePoint = new Proj4js.Point(miX + "," + miY);
        var point = Proj4js.transform(projSourceCG, projDestCG, thePoint);
        return point;
    },

    getXlinkStop: function(array, point) {
        var xlinkCode = null;
        $.each(array, function(i, item) {
            if ('StopPoint' in item.StopPointInServicePattern.point) {
                var stopPoint = item.StopPointInServicePattern.point.StopPoint;

                $.each(stopPoint, function(key, value) {
                    //var xlinkPoint = pageStops.getXlinkStop(data.featureMembers.ServicePattern.serviceLinkSequence.LinkSequenceAsPoints.points, value.replace("#StopPoint:", ""));
                    //var kk = value.replace("#StopPoint:", "");
                    var xlinkStop = stopPoint["gml:id"].replace("StopPoint:", "");
                    if (xlinkStop == point)
                        xlinkCode = item.StopPointInServicePattern.point.StopPoint.stopPointId.StopPointCode.identifier;
                });
            }

        });


        return xlinkCode;
    },


    getXlinkStop2: function(array, point) {

        var xlinkCode = null;
        $.each(array, function(i, item) {
            if ('StopPoint' in item.StopPointInServicePattern.point) {
                var stopPoint = item.StopPointInServicePattern.point;

                $.each(stopPoint, function(key, value) {
                    if (value["gml:id"] != undefined) {
                        var xlinkStop = value["gml:id"].replace("StopPoint:", "");
                        if (xlinkStop == point) {
                            xlinkCode = item.StopPointInServicePattern.point.StopPoint.stopPointId.StopPointCode.identifier;
                        }

                    }



                });
            }

        });


        return xlinkCode;
    },
    getRouteFromGeoBilbaoAll: function(direction, linea) {
        functionsGlobals.showLoading();


        for (var i = 0; i < stopMarker.length; i++) {
            stopMarker[i].setMap(null);
        }

        for (var i = 0; i < busMarker.length; i++) {
            busMarker[i].setMap(null);
        }


        // PINTADO DE RECORRIDO
        connection.getResponse(aConfig["URL_RUTA_LINEA"] + linea + direction, "json")
            .done(function(data_response) {

                var color = functionsGlobals.getColorLine(linea);

                var aux_aRoute = [];

                for (var x = 0, len = data_response.features.length; x < len; x++) {
                    aux_aRoute.push({
                        coordinates: []
                    });

                    for (var y = 0, len2 = data_response.features[x].geometry.coordinates.length; y < len2; y++)
                        for (var z = 0, len3 = data_response.features[x].geometry.coordinates[y].length; z < len3; z++) {
                            var point = functionsGlobals.cambiarCimubisaGoogle(data_response.features[x].geometry.coordinates[y][z][0], data_response.features[x].geometry.coordinates[y][z][1]);

                            aux_aRoute[x].coordinates.push({
                                lat: point.y,
                                lng: point.x
                            });
                        }
                }

                $.each(aux_aRoute, function(i, item) {
                    var flightPath = new google.maps.Polyline({
                        path: item.coordinates,
                        geodesic: true,
                        strokeColor: color,
                        strokeOpacity: 1.0,
                        strokeWeight: 4
                    });

                    flightPath.setMap(map);
                });

            }); //.done PINTADO DE RECORRIDO



        // PINTADO DE AUTOBUSES
        connection.getResponse(aConfig["URL_RUTA_AUTOBUSES"] + linea + direction + "&", "json")
            .done(function(data_response) {

                $.each(data_response.features, function(i, item) {
                    var point = functionsGlobals.cambiarCimubisaGoogle(item.geometry.coordinates[0], item.geometry.coordinates[1]);

                    uPoint = new google.maps.LatLng(point.y, point.x);

                    stopicon = {
                        url: "img/map/stops/" + linea + ".png",
                        size: new google.maps.Size(32, 38),
                        scaledSize: new google.maps.Size(32, 38)
                    };

                    busMarker[i] = new google.maps.Marker({
                        map: map,
                        position: uPoint,
                        title: item.properties.NombreParada,
                        visible: true,
                        icon: stopicon,
                        stop: item.properties.ParadaAutobus
                    });
                });
            }); //.done PINTADO DE AUTOBUSES


        // PINTADO DE PARADAS

        connection.getResponse(aConfig["URL_RUTA_PARADAS"] + linea + direction + "&", "json")
            .done(function(data_response) {

                $.each(data_response.features, function(i, item) {
                    var point = functionsGlobals.cambiarCimubisaGoogle(item.geometry.coordinates[0][0], item.geometry.coordinates[0][1]);

                    uPoint = new google.maps.LatLng(point.y, point.x);

                    stopicon = {
                        url: "img/map/stops/P" + linea + ".png",
                        size: new google.maps.Size(32, 37),
                        scaledSize: new google.maps.Size(32, 37)
                    };

                    stopMarker[i] = new google.maps.Marker({
                        map: map,
                        position: uPoint,
                        title: item.properties.NombreParada,
                        visible: true,
                        icon: stopicon,
                        stop: item.properties.ParadaAutobus
                    });
                });
            }); //.done PINTADO DE PARADAS


        functionsGlobals.hideLoading();
    },

    getRouteFromGeoBilbao: function(direction, linea) {
        functionsGlobals.showLoading();


        for (var i = 0; i < stopMarker.length; i++) {
            stopMarker[i].setMap(null);
        }

        for (var i = 0; i < busMarker.length; i++) {
            busMarker[i].setMap(null);
        }


        // PINTADO DE RECORRIDO
        connection.getResponse(aConfig["URL_RUTA_LINEA"] + linea + direction, "json")
            .done(function(data_response) {

                var color = functionsGlobals.getColorLine(linea);

                var aux_aRoute = [];

                for (var x = 0, len = data_response.features.length; x < len; x++) {
                    aux_aRoute.push({
                        coordinates: []
                    });

                    for (var y = 0, len2 = data_response.features[x].geometry.coordinates.length; y < len2; y++)
                        for (var z = 0, len3 = data_response.features[x].geometry.coordinates[y].length; z < len3; z++) {
                            var point = functionsGlobals.cambiarCimubisaGoogle(data_response.features[x].geometry.coordinates[y][z][0], data_response.features[x].geometry.coordinates[y][z][1]);

                            aux_aRoute[x].coordinates.push({
                                lat: point.y,
                                lng: point.x
                            });
                        }
                }

                $.each(aux_aRoute, function(i, item) {
                    var flightPath = new google.maps.Polyline({
                        path: item.coordinates,
                        geodesic: true,
                        strokeColor: color,
                        strokeOpacity: 1.0,
                        strokeWeight: 4
                    });

                    flightPath.setMap(map);
                });

            }); //.done PINTADO DE RECORRIDO



        // PINTADO DE AUTOBUSES
        connection.getResponse(aConfig["URL_RUTA_AUTOBUSES"] + linea + direction + "&", "json")
            .done(function(data_response) {

                $.each(data_response.features, function(i, item) {
                    var point = functionsGlobals.cambiarCimubisaGoogle(item.geometry.coordinates[0], item.geometry.coordinates[1]);

                    uPoint = new google.maps.LatLng(point.y, point.x);

                    stopicon = {
                        url: "img/map/stops/" + linea + ".png",
                        size: new google.maps.Size(32, 38),
                        scaledSize: new google.maps.Size(32, 38)
                    };

                    busMarker[i] = new google.maps.Marker({
                        map: map,
                        position: uPoint,
                        title: item.properties.NombreParada,
                        visible: true,
                        icon: stopicon,
                        stop: item.properties.ParadaAutobus
                    });
                });
            }); //.done PINTADO DE AUTOBUSES


        functionsGlobals.hideLoading();
    },

    getBusPosition: function(direction, linea) {
        functionsGlobals.showLoading();

        for (var i = 0; i < busMarker.length; i++) {
            busMarker[i].setMap(null);
        }

        // PINTADO DE AUTOBUSES
        connection.getResponse(aConfig["URL_RUTA_AUTOBUSES"] + linea + direction + "&", "json")
            .done(function(data_response) {

                $.each(data_response.features, function(i, item) {
                    var point = functionsGlobals.cambiarCimubisaGoogle(item.geometry.coordinates[0], item.geometry.coordinates[1]);

                    uPoint = new google.maps.LatLng(point.y, point.x);

                    stopicon = {
                        url: "img/map/stops/" + linea + ".png",
                        size: new google.maps.Size(32, 38),
                        scaledSize: new google.maps.Size(32, 38)
                    };

                    busMarker[i] = new google.maps.Marker({
                        map: map,
                        position: uPoint,
                        title: item.properties.NombreParada,
                        visible: true,
                        icon: stopicon,
                        stop: item.properties.ParadaAutobus
                    });
                });
            }); //.done PINTADO DE AUTOBUSES

        /*timeoutReloadRoute = setTimeout(function()
			{
	           functionsGlobals.getBusPosition(direction, linea);
	        }, 5000);
	        */

        functionsGlobals.hideLoading();
    },


    showMessage: function(message, content) {
        if (window.plugins && window.plugins.toast) {
            duration = "short";
            position = "center";

            window.plugins.toast.show(message, duration, position);
            navigator.vibrate(200);
        } else {
            alert(message);
        }

        $(".info_error h1").text(message);

        if (content == null) {
            $(".info_error_bordes").show();
            $("#info_error_title").text(gjson_lang['info_error']);
        } else
            $(".info_error_bordes").hide();


        $(".info_error").show();

        functionsGlobals.hideLoading();
    },

    alertDismissed: function() {
        functionsGlobals.hideLoading();
    },

    comprobarConexion: function() {
        if (checkConnection() == 0 || checkConnection() == 6) {
            functionsGlobals.showMessage(gjson_lang['connectionError'], "");
            return false;
        } else
            return true;
    },

    getNotificationTags: function(resultCallback) {
        if (fcmToken != "") {
            $.ajax({
                    beforeSend: function(xhr) {
                        xhr.setRequestHeader('Authorization', 'key=' + SERVER_KEY);
                        xhr.setRequestHeader('Content-Type', 'aplication/json');
                    },
                    url: "https://iid.googleapis.com/iid/info/" + fcmToken + "?details=true",
                    dataType: "json",
                    cache: false,
                    async: false
                })
                .success(function(json) {
                    if (!json.rel)
                        resultCallback([]);
                    else {
                        var topics = Object.keys(json.rel.topics);
                        localStorage.setItem("push_tags_subscribed", JSON.stringify(topics));
                        resultCallback(topics);
                    }
                })
                .error(function(xhRequest, textStatus, errorThrown) {
                    resultCallback([]);
                });
        }
    },

    addNotificationTag: function(tag, successCallback) {
        FCMPlugin.subscribeToTopic(tag, successCallback);
        //console.log("ADD TOPIC: ",tag);
    },

    deleteNotificationTag: function(tag, successCallback)  {
        FCMPlugin.unsubscribeFromTopic(tag, successCallback);
        //console.log("REMOVE TOPIC: ",tag);
    },

    getLocalNotificationTags: function(resultCallback) {
        var tags = localStorage.getItem("push_tags_subscribed");

        if (typeof tags === 'undefined' || tags === null) {
            localStorage.setItem("push_tags_subscribed", JSON.stringify([]));
            functionsGlobals.getNotificationTags(resultCallback);
        } else
            resultCallback(JSON.parse(tags));
    },

    addLocalNotificationTag: function(tagToAdd, successCallback) {
        var tags = localStorage.getItem("push_tags_subscribed") || [];
        var parsed_tags = JSON.parse(tags);

        if (parsed_tags.indexOf(tagToAdd) == -1) {
            parsed_tags.push(tagToAdd);
            localStorage.setItem("push_tags_subscribed", JSON.stringify(parsed_tags));

            functionsGlobals.addNotificationTag(tagToAdd, successCallback);
        } else if (successCallback && typeof successCallback == "function")
            successCallback();

    },

    deleteLocalNotificationTag: function(tagToDelete, successCallback) {
        var tags = localStorage.getItem("push_tags_subscribed");
        var parsed_tags = JSON.parse(tags);

        if (parsed_tags.indexOf(tagToDelete) != -1) {
            parsed_tags.splice(parsed_tags.indexOf(tagToDelete), 1);
            localStorage.setItem("push_tags_subscribed", JSON.stringify(parsed_tags));

            functionsGlobals.deleteNotificationTag(tagToDelete, successCallback);
        } else if (successCallback && typeof successCallback == "function")
            successCallback();

    },

    deleteAllNotificationTags: function(successCallback) {
        functionsGlobals.getLocalNotificationTags(function(tags) {
            tags.forEach(function(current_tag) {
                functionsGlobals.deleteLocalNotificationTag(current_tag);
            });

            if (successCallback && typeof successCallback == "function")
                successCallback();
        });
    }

};

function getValues(obj, key) {
    var objects = [];
    for (var i in obj) {
        if (!obj.hasOwnProperty(i)) continue;
        if (typeof obj[i] == 'object') {
            objects = objects.concat(getValues(obj[i], key));
        } else if (i == key) {
            objects.push(obj[i]);
        }
    }
    return objects;
};

function array_unique(inputArr) {
    var key = '',
        tmp_arr2 = {},
        val = '';

    var __array_search = function(needle, haystack) {
        var fkey = '';
        for (fkey in haystack) {
            if (haystack.hasOwnProperty(fkey)) {
                if ((haystack[fkey] + '') === (needle + '')) {
                    return fkey;
                }
            }
        }
        return false;
    };

    for (key in inputArr) {
        if (inputArr.hasOwnProperty(key)) {
            val = inputArr[key];
            if (false === __array_search(val, tmp_arr2)) {
                tmp_arr2[key] = val;
            }
        }
    }

    return tmp_arr2;
}



function getDirection(item) {
    var idLinea = item.isPartOf.EstimatedVehicleJourney.hasJourneyPatternInfo.JourneyPatternInfo.externalLineRef.LineCode.identifier;
    var destino = item.isPartOf.EstimatedVehicleJourney.hasJourneyPatternInfo.JourneyPatternInfo.directionName.PT_FreeText.textGroup.LocalisedCharacterString;

    switch (idLinea) {

        case "01":
            if (destino == "PLAZA BIRIBILA") direction = 0;
            else direction = 1;
            break;

        case "03":
            if (destino == "OTXARKOAGA") direction = 0;
            else direction = 1;
            break;

        case "10":
            if (destino == "PLAZA BIRIBILA") direction = 0;
            else direction = 1;
            break;

        case "11":
            if (destino == "ATXURI") direction = 0;
            else direction = 1;
            break;

        case "13":
            if (destino == "TXURDINAGA") direction = 0;
            else direction = 1;
            break;

        case "18":
            if (destino == "ZORROTZA") direction = 0;
            else direction = 1;
            break;

        case "22":
            if (destino == "ATXURI") direction = 0;
            else direction = 1;
            break;

        case "26":
            if (destino == "BASURTU/TERMIBUS") direction = 0;
            else direction = 1;
            break;

        case "27":
            if (destino == "BETOLAZA") direction = 0;
            else direction = 1;
            break;

        case "28":
            if (destino == "ALTAMIRA") direction = 0;
            else direction = 1;
            break;

        case "30":
            if (destino == "MIRIBILLA") direction = 0;
            else direction = 1;
            break;

        case "34":
            if (destino == "OTXARKOAGA") direction = 0;
            else direction = 1;
            break;

        case "38":
            if (destino == "BASURTU/TERMIBUS") direction = 0;
            else direction = 1;
            break;

        case "40":
            if (destino == "AYALA") direction = 0;
            else direction = 1;
            break;

        case "43":
            if (destino == "SANTUTXU") direction = 0;
            else direction = 1;
            break;

        case "48":
            if (destino == "LEZEAGA") direction = 0;
            else direction = 1;
            break;

        case "50":
            if (destino == "LA PEÑA") direction = 0;
            else direction = 1;
            break;

        case "56":
            if (destino == "JESUSEN BIHOTZA") direction = 0;
            else direction = 1;
            break;

        case "57":
            if (destino == "OSPITALEA") direction = 0;
            else direction = 1;
            break;

        case "58":
            if (destino == "ATXURI") direction = 0;
            else direction = 1;
            break;

        case "62":
            if (destino == "ARABELLA") direction = 0;
            else direction = 1;
            break;

        case "71":
            if (destino == "SAN IGNAZIO") direction = 0;
            else direction = 1;
            break;

        case "72":
            if (destino == "CASTAÑOS") direction = 0;
            else direction = 1;
            break;

        case "75":
            if (destino == "ATXURI") direction = 0;
            else direction = 1;
            break;

        case "76":
            if (destino == "PLAZA MOYUA") direction = 0;
            else direction = 1;
            break;

        case "77":
            if (destino == "MINA DEL MORRO") direction = 0;
            else direction = 1;
            break;

        case "80":
            if (destino == "BASURTU/TERMIBUS") direction = 0;
            else direction = 1;
            break;

        case "85":
            if (destino == "ATXURI") direction = 0;
            else direction = 1;
            break;

        case "88":
            if (destino == "INDAUTXU") direction = 0;
            else direction = 1;
            break;

        case "A1":
            if (destino == "PLAZA BIRIBILA") direction = 0;
            else direction = 1;
            break;

        case "A2":
            if (destino == "PLAZA BIRIBILA") direction = 0;
            else direction = 1;
            break;

        case "A3":
            if (destino == "MOYUA") direction = 0;
            else direction = 1;
            break;

        case "A4":
            if (destino == "DEUSTU") direction = 0;
            else direction = 1;
            break;

        case "A5":
            if (destino == "PLAZA BIRIBILA") direction = 0;
            else direction = 1;
            break;

        case "A6":
            if (destino == "PLAZA SAN PEDRO") direction = 0;
            else direction = 1;
            break;

        case "A7":
            if (destino == "SENDEJA") direction = 0;
            else direction = 1;
            break;

        case "A8":
            if (destino == "AMETZOLA") direction = 0;
            else direction = 1;
            break;

        case "G1":
            if (destino == "MOYUA") direction = 0;
            else direction = 1;
            break;

        case "G2":
            if (destino == "PLAZA BIRIBILA") direction = 0;
            else direction = 1;
            break;

        case "G3":
            if (destino == "PLAZA BIRIBILA") direction = 0;
            else direction = 1;
            break;

        case "G4":
            if (destino == "PLAZA BIRIBILA") direction = 0;
            else direction = 1;
            break;

        case "G5":
            if (destino == "PLAZA BIRIBILA") direction = 0;
            else direction = 1;
            break;

        case "G6":
            if (destino == "PLAZA BIRIBILA") direction = 0;
            else direction = 1;
            break;

        case "G7":
            if (destino == "PLAZA BIRIBILA") direction = 0;
            else direction = 1;
            break;

        case "G8":
            if (destino == "PLAZA BIRIBILA") direction = 0;
            else direction = 1;
            break;

        default:
            direction = 0;

    }

    return direction;

}


String.format = function() {
    var s = arguments[0];
    if ($.isArray(arguments[1])) {
        for (var i = 0, len = arguments[1].length; i < len; i++) {
            var reg = new RegExp("\\{" + i + "\\}", "gm");
            s = s.replace(reg, arguments[1][i]);
        }
    } else {
        for (var i = 0, len = arguments.length - 1; i < len; i++) {
            var reg = new RegExp("\\{" + i + "\\}", "gm");
            s = s.replace(reg, arguments[i + 1]);
        }
    }
    return s;
};

/* VARIABLES */

var gb_isCordovaLoaded = false;
var gb_isPageIndexShowed = false;

var gjson_lang = null;
functionsGlobals.loadLanguage();
//functionsGlobals.getConfiguration();
functionsGlobals.getConfigurationLocal();

var flightPath;
var stopMarker = [];
var busMarker = [];

$.widget("ui.tabs", $.ui.tabs, {

    _createWidget: function(options, element) {
        var page, delayedCreate,
            that = this;

        if ($.mobile.page) {
            page = $(element)
                .parents(":jqmData(role='page'),:mobile-page")
                .first();

            if (page.length > 0 && !page.hasClass("ui-page-active")) {
                delayedCreate = this._super;
                page.one("pagebeforeshow", function() {
                    delayedCreate.call(that, options, element);
                });
            }
        } else {
            return this._super();
        }
    }
});