/* CSS */
$( "body" ).append('<link rel="stylesheet" type="text/css" href="css/pageAbout.css"/>');

/* VARIABLES */
var pageAbout = {
		
	$page : null,

	init: function() 
	{
		pageAbout.addContent();
		pageAbout.getData();

	},

	addContent : function() 
	{
		pageAbout.$page.find("#page_title").text(gjson_lang['page_title_about']);
	},

	getData : function() 
	{
    	functionsGlobals.showLoading();
    	  	 
        connection.getResponse(aConfig["URL_JSON_ABOUT"], "json")
            .done(function(data_response) {
                functionsGlobals.hideLoading();
                      pageAbout.showData(data_response);
            });
	},

	showData : function(data) 
	{
		var content_ayuntamiento = eval("data.content_ayuntamiento_"+language);
		var content_normal =  eval("data.content_normal_"+language);
		var content_horario_normal =  eval("data.content_horario_normal_"+language);
		var content_verano =  eval("data.content_verano_"+language);
		var content_verano_normal =  eval("data.content_horario_verano_"+language);

		pageAbout.$page.find("#about_ayuntamiento p").empty().append(content_ayuntamiento);

		pageAbout.$page.find("#about_horario .normal").empty().append(content_normal);
		pageAbout.$page.find("#about_horario .normal_horario").empty().append(content_horario_normal);

		pageAbout.$page.find("#about_horario .verano").empty().append(content_verano);
		pageAbout.$page.find("#about_horario .verano_horario").empty().append(content_verano_normal);

		pageAbout.$page.find("#about_direccion p").empty().append(data.content_direccion);		

		pageAbout.$page.find("#about_telephone").attr("href", "tel:"+data.telephone);		
		pageAbout.$page.find("#about_telephone").text(data.telephone);

		pageAbout.$page.find("#about_mail").attr("href", "mailto:"+data.mail);		
		pageAbout.$page.find("#about_mail").text(data.mail);

		pageAbout.$page.find("#about_url").attr("href", "http://"+data.url);		
		pageAbout.$page.find("#about_url").text(data.url);	

		pageAbout.$page.find("#about_app_version").text(gjson_lang.version+" "+app_version);			

	}


};

/* EVENTS */

$( document ).off(".about")

	.on("pagecreate.about", "#page_about", function()
	{
		pageAbout.$page = $(this);
	})

	.on("pageshow.about", "#page_about", function()
	{
		pageAbout.init();

	})

	.on("pageremove.about", "#page_about", function()
	{
		$( window ).off( ".about" );
		$( document ).off(".about");
		$( 'link[href="css/pageAbout.css"]' ).remove();
		pageAbout = null;
	});

