/* CSS */
$( "body" ).append('<link rel="stylesheet" type="text/css" href="css/pageFavoritesLineas.css"/>');

/* VARIABLES */
var pageFavoritesLineas = {
		
	$page : null,
	actual_line : 'regular',
	carga_lineas : false,
	carga_paradas : false,

	init: function() 
	{
		pageFavoritesLineas.addContent();
	},

	addContent : function() 
	{
		pageFavoritesLineas.$page.find("#page_title").text(gjson_lang['page_title_favorites']);

		var aFavorites = JSON.parse(localStorage.getItem("array_favorites_lineas")) || [];

		if (aFavorites.length == 0 || !localStorage.getItem("array_favorites_lineas"))
			functionsGlobals.showMessage(gjson_lang['no_favorites_list'], "");
		else
			pageFavoritesLineas.getData(JSON.parse(localStorage.getItem("array_favorites_lineas")));
	},

	getData : function(data) 
	{
		var dataAUX = [];
		var aFavorites = [];

		var data = JSON.parse(localStorage.getItem("array_favorites_lineas"));


		pageFavoritesLineas.$page.find("#favorites_content_lineas").empty();

		data.sort(functionsGlobals.SortByLinea);
		
		$.each( data, function( i, item ) 
		{

			html = '<li data-filtertext="'+item.name_linea+'">'+
					'<a href = "#" data-line= "'+item.id_linea+'" data-Route0="'+item.id_Route0+'" data-Route1="'+item.id_Route1+'">'+ 
					'<div class="line_list_id" style="color:'+functionsGlobals.getColorLine(item.id_linea)+'">'+ item.id_linea + '</div>' + 
					'<div class="name_linea">'+ item.name_linea + '</div>'+
					'<div class = "div_favorite" id ="favorite'+i+'"></div>'+
					'<div class="listview_border"></div>'+
					'</li></a>';


/*var html = '<li  data-icon = "false" ><a href = "#" data-stop="'+aStops[i].idParada+'"> ' + 
							'<div class = "ui-grid-a">'+
							'<div class="StopName ui-block-a">'+ aStops[i].idParada +" - " +aStops[i].nameParada+ '</div>'+
							'<div class="stopDistance ui-block-b">'+distance+ ' m</div></div></div>'+
							'<div class="stop_list_lines" id="stop'+pos+'">' + 
							'</div>' + 
							'<div class = "div_favorite" id ="favorite'+pos+'"></div>'+
							'<div class="listview_border"></div>'+
							'</li></a>';
*/

			pageFavoritesLineas.$page.find("#favorites_content_lineas").append(html);

			if (functionsGlobals.isFavoriteLine(item.id_linea))
				{
					pageFavoritesLineas.$page.find("#favorite"+i).append('<div class = "icon_favorite"><img src="img/stops/lista_favorito.png"></div>');
				}		
		});

		functionsGlobals.hideLoading();
		
	}

};

/* EVENTS */

$( document ).off(".favorites_lineas")

	.on("pagecreate.favorites_lineas", "#page_favorites_lineas", function()
	{
		pageFavoritesLineas.$page = $(this);
	})

	.on("pageshow.favorites_lineas", "#page_favorites_lineas", function()
	{
		pageFavoritesLineas.init();
		functionsGlobals.deleteSessionStorage();
	})

	.on("click.favorites_lineas", "#page_favorites_lineas #favorites_content_lineas a", function(event)
	{
		event.preventDefault();
		sessionStorage.setItem("codigoLineaActiva", $(this).attr('data-line'));
		
		var names = $(this).find(".name_linea").text().split('-');

		sessionStorage.setItem("name_linea", $.trim(names[0])+" - "+$.trim(names[1]));
		sessionStorage.setItem("name_linea"+$(this).attr("data-Route0"), $.trim(names[0])+" - "+$.trim(names[1]));
		sessionStorage.setItem("name_linea"+$(this).attr("data-Route1"), $.trim(names[1])+" - "+$.trim(names[0]));
		sessionStorage.setItem("back_favorite", "no");

		$( "body" ).pagecontainer( "change", "stops.html?filter=" + $(this).attr("data-Route0") +'&filter2=' + $(this).attr("data-Route1"));
		return false;	
	})

	.on("pageremove.favorites_lineas", "#page_favorites_lineas", function()
	{
		$( window ).off( ".favorites_lineas" );
		$( document ).off(".favorites_lineas");
		$( 'link[href="css/pageFavoritesLineas.css"]' ).remove();
		pageFavoritesLineas = null;
	});