/* CSS */
$( "body" ).append('<link rel="stylesheet" type="text/css" href="css/pageLost.css"/>');

/* VARIABLES */
var pageLost = {
		
	$page : null,

	init: function() 
	{
		pageLost.addContent();
		pageLost.getData();
	},

	addContent : function() 
	{
		pageLost.$page.find("#page_title").text(gjson_lang['page_title_lost']);
	},

	getData : function() 
	{

    	functionsGlobals.showLoading();
    	  	 
	    connection.getResponse(aConfig["URL_JSON_LOST"], "json")
            .done(function(data_response) {
                      pageLost.showData(data_response);
        });
	},

	showData : function(data) 
	{
		var html="";
		//data = jQuery.parseJSON(data);

		pageLost.$page.find("#lost_content").empty().append(eval("data.content_"+language));

		html = '<a  class="lost-telephone-call" href="tel:'+data.telephone.replace(/\./g,' ')+'">'+
			   '<img src="img/btn_telephone.png" class="btn_icon_tel">'+data.telephone+'</a>';

		pageLost.$page.find("#lost_telephone").empty().append(html);
		functionsGlobals.hideLoading();

	}


};

/* EVENTS */

$( document ).off(".lost")

	.on("pagecreate.lost", "#page_lost", function()
	{
		pageLost.$page = $(this);
	})

	.on("pageshow.lost", "#page_lost", function()
	{
		pageLost.init();
	})

	.on("pageremove.lost", "#page_lost", function()
	{
		$( window ).off( ".lost" );
		$( document ).off(".lost");
		$( 'link[href="css/pageLost.css"]' ).remove();
		pageLost = null;
	});

