/* CSS */
$( "body" ).append('<link rel="stylesheet" type="text/css" href="css/pageNotifications.css"/>');

/* VARIABLES */
var pageNotifications = {
		
	$page : null,
	actual_line : 'regular',
	carga_lineas : false,

	init: function() 
	{
		pageNotifications.addContent();
		pageNotifications.getData();
	},

	addContent : function() 
	{
		pageNotifications.$page.find("#page_title").text(gjson_lang['page_title_notifications']);
	},

	getData : function() 
	{
    	functionsGlobals.showLoading();

		if( !localStorage.getItem("array_lineas") || !localStorage.getItem("array_paradas"))
		{
	       	sessionStorage.setItem("activeFunction", "pageNotifications.showLines()");

			CallServiceCAI(aConfig["gstr_webServiceURLCAI"], createSoapRequestgetStops(), "functionsGlobals.saveStops");
	        CallServiceCAI(aConfig["gstr_webServiceURLCAI"], SoapgetLines(), "pageNotifications.LoadLines");	        	
		
		}
		else
		{
			pageNotifications.showLines();
			functionsGlobals.hideLoading();
		}

	},

	LoadLines : function(data) 
	{

		var aLineas = [];

		$.each( data.featureMembers.Line, function( i, item ) 
		{

			if (item.routesForLine != undefined)
			{
				if(item.routesForLine[0].Route.direction.Direction.identity.DirectionCode.identifier == "IDA")
					aLineas.push({
						id_linea: item.identity.LineCode.identifier,
						name_linea: item.lineName,
						id_Route0: item.routesForLine[0].Route.identity.RouteCode.identifier,
						id_Route1: item.routesForLine[1].Route.identity.RouteCode.identifier
					});		
				else
					aLineas.push({
						id_linea: item.identity.LineCode.identifier,
						name_linea: item.lineName,
						id_Route0: item.routesForLine[1].Route.identity.RouteCode.identifier,
						id_Route1: item.routesForLine[0].Route.identity.RouteCode.identifier
					});					
			}

		});

		
		localStorage.setItem("array_lineas", JSON.stringify(aLineas));
		pageNotifications.showLines();

	},

	showLines : function() 
	{
		var html="";
		var html_todas="";
		var option_select="";
		var data = JSON.parse(localStorage.getItem("array_lineas"));


		pageNotifications.$page.find("#notifications_content").empty();

		var html_todas = '<li class = "ui-block-a" id = "li_line_00">'+
					   '<a href = "#" data-line= "00"> '+
					   '<div class="line_list_id line-color-div-00">'+ "T" + '</div>' + 
					   '<div class="name_linea">'+ "Todas las líneas" + '</div><div class="listview_border"></div></li>'+
					   '<div class = "ui-block-b">'+
					   '<select name="check_'+language+'_00" id="check_'+language+'_00" data-tag= "'+language+'_00" class = "addTag00" data-role="slider">'+
					   '<option value="off">'+gjson_lang['str_no']+'</option>'+
                       '<option value="on">'+gjson_lang['str_yes']+'</option>'+
					   '</select><div class="listview_border_slider"></div></div>'+
					   '</a>';

		pageNotifications.$page.find("#notifications_content").append(html_todas);
		pageNotifications.$page.find("#check_es_00").slider();
		pageNotifications.$page.find("#check_eu_00").slider();
		pageNotifications.$page.find("#check_en_00").slider();

		data.sort(functionsGlobals.SortByLinea);
		
		$.each( data, function( i, item ) 
		{
			if ( pageNotifications.actual_line == "regular") cond = 'item.id_linea.indexOf("A") && item.id_linea.indexOf("G") && item.id_linea.indexOf("E")';
			if ( pageNotifications.actual_line == "auzolineas") cond = 'item.id_linea.indexOf("A") != -1';
			if ( pageNotifications.actual_line == "gautxori") cond = 'item.id_linea.indexOf("G") != -1';
			if ( pageNotifications.actual_line == "especiales") cond = 'item.id_linea.indexOf("E") != -1';
			
			if( eval(cond) )
			{
				html = '<li class = "ui-block-a item_push" id = "li_line_'+item.id_linea+'">'+
					   '<a href = "#" data-line= "'+item.id_linea+'" data-Route0="'+item.id_Route0+'" data-Route1="'+item.id_Route1+'"> '+
					   '<div class="line_list_id" style="color:'+functionsGlobals.getColorLine(item.id_linea)+'">'+ item.id_linea + '</div>' + 
					   '<div class="name_linea">'+ item.name_linea + '</div><div class="listview_border"></div></li>'+
					   '<div class = "ui-block-b item_push">'+
					   '<select name="check_'+language+"_"+item.id_linea+'" id="check_'+language+"_"+item.id_linea+'" data-tag= "'+language+"_"+item.id_linea+'"class = "addTag" data-role="slider">'+
					   '<option value="off">'+gjson_lang['str_no']+'</option>'+
                       '<option value="on">'+gjson_lang['str_yes']+'</option>'+
					   '</select><div class="listview_border_slider"></div></div>'+
					   '</a>';

				pageNotifications.$page.find("#notifications_content").append(html).listview( "refresh" );
				pageNotifications.$page.find("#check_"+language+"_"+item.id_linea).slider();

                
                //$('select').selectmenu();
                //pageNotifications.$page.find("#check_"+item.id_linea).append(option_select).slider( "refresh" );
			}			
		});	

		pageNotifications.loadTags();

	},

	loadTags : function ()
	{
		functionsGlobals.getLocalNotificationTags(function(tags) {
			var has00Tag = false;
			var tag00 = "";

			tags.forEach(function(tag) {
				pageNotifications.$page.find("#check_"+tag).val('on').slider("refresh");

				if(tag.includes("_00"))
				{
					tag00 = tag;
					has00Tag = true;
				}
			});

			if(has00Tag){
				var arrayWithoutTag00 = tags.splice(tags.indexOf(tag00), 1);
				pageNotifications.switchOffTags(arrayWithoutTag00);
			}
        })
	},

	

	switchOffTags: function()
	{
		pageNotifications.$page.find( ".item_push" ).css("opacity", ".3");
		pageNotifications.$page.find( ".addTag" ).slider( "disable" );
		pageNotifications.$page.find(".addTag").val('off');
		pageNotifications.$page.find(".addTag").slider("refresh");
	},

	switchOnTags: function()
	{
		pageNotifications.$page.find( ".item_push" ).css("opacity", "1");
		pageNotifications.$page.find( ".addTag" ).slider( "enable" );	
	},

	quitarLoading : function(data) 
	{		
		if(pageNotifications.carga_lineas && functionsGlobals.carga_paradas)
			functionsGlobals.hideLoading();
	}

};

/* EVENTS */

$( document ).off(".notifications")

	.on("pagecreate.notifications", "#page_notifications", function()
	{
		functionsGlobals.deleteStops();
		pageNotifications.$page = $(this);
	})


	.on("pageshow.notifications", "#page_notifications", function()
	{
		pageNotifications.init();
		functionsGlobals.deleteSessionStorage();
	})
	.on("click.notifications", "#page_notifications .footer_links", function(event)
	{
		event.preventDefault();
		pageNotifications.$page.find(".footer_links").removeClass('ui-btn-active');
		$(this).addClass('ui-btn-active');
		pageNotifications.actual_line = $(this).attr('data-line');
		pageNotifications.showLines();
		return false;	
	})


	.on("change.notifications", ".addTag, .addTag00", function(event)
	{
		event.preventDefault();
		functionsGlobals.showLoading();
		var option = $(this).val();
		var tag = $(this).attr("data-tag");

		if (option == "on" && tag.includes("_00")) 
		{
			functionsGlobals.deleteAllNotificationTags( function()
			{
				pageNotifications.switchOffTags();
			});
			
		}
		else if( option == "off" && tag.includes("_00") )
			pageNotifications.switchOnTags();	


		if( option == "on" )
			functionsGlobals.addLocalNotificationTag(tag, functionsGlobals.hideLoading);

		else if( option == "off" )
			functionsGlobals.deleteLocalNotificationTag(tag, functionsGlobals.hideLoading);


		return false;          
	})
	
	.on("pageremove.notifications", "#page_notifications", function()
	{
		$( document ).off(".notifications");
		$( 'link[href="css/pageNotifications.css"]' ).remove();
		pageNotifications = null;
	});