/* CSS */
$( "body" ).append('<link rel="stylesheet" type="text/css" href="css/pagePushNews.css"/>');

/* VARIABLES */
var pagePushNews = {
		
	$page : null,
	active_tab : 4,


	init: function() 
	{
		pagePushNews.getData();
		//pagePushNews.getData();
	},

	getData : function() 
	{

		functionsGlobals.showLoading();
		pagePushNews.showNotifications();		
	},

	showNotifications : function() 
	{
		pagePushNews.$page.find("#page-push-news-list").empty();
		var Notifications = JSON.parse(localStorage.getItem("BilbobusPush")) || [];
		
		if(Notifications.length > 0)
		{
			Notifications.sort(functionsGlobals.SortByPushDate);	
			
			$.each( Notifications, function( i, item ) 
			{
								var html = '<a href = "pushNews2.html?line='+item.linea+'&push_id='+item.push_id+'">'+
							'<li data-icon="false">'+ 
							'<h1>'+gjson_lang['suggestions_send_line']+' '+item.linea+'</h1>'+
							'<p class = "news_date">'+ item.fecha +" "+item.hora + '</p>'+
							'<p class="titulo">'+item.alert+'</p>'+
							'</li></a>';
							pagePushNews.$page.find("#page-push-news-list").append(html);	
			});

			pagePushNews.$page.find('#page-push-news-list').listview('refresh');			
		}else
		{
			//functionsGlobals.showMessage(gjson_lang['no_datos'], null);
			$( "body" ).pagecontainer( "change", "notifications.html");
		}

		functionsGlobals.hideLoading();
	},


};

/* EVENTS */

$( document ).off(".pushNews")

	.on("pagecreate.pushNews", "#page_pushNews", function()
	{
		pagePushNews.$page = $(this);
	})

	.on("pageshow.pushNews", "#page_pushNews", function()
	{
		pagePushNews.init();
		localStorage.removeItem("external_push");
	})

	.on("pageremove.pushNews", "#page_pushNews", function()
	{
		$( window ).off( ".pushNews" );
		$( document ).off(".pushNews");
		$( 'link[href="css/pagePushNews.css"]' ).remove();
		pagePushNews = null;
	});
