/* CSS */
$( "body" ).append('<link rel="stylesheet" type="text/css" href="css/pageScheduleSel.css"/>');

/* VARIABLES */
var pageScheduleSel = {
		
	$page : null,

	getData : function() 
	{
		var object = "array_lineasParadas"+sessionStorage.getItem("direction");

		var name = "name_linea"+sessionStorage.getItem("direction");

		var line_name = sessionStorage.getItem(name);

		var data = JSON.parse(localStorage.getItem(object));

		var aParadas = [];

		$("#scheduleSel_line").text(line_name);
		
		$.each(data, function( i, item ) 
		{
			aParadas.push({
				idParada: item.idParada,
				nameParada: item.nameParada,
				orden: item.orden
			});	
		});

		for( var i = 0; i < aParadas.length; i++){
				for( var x = i+1; x < aParadas.length; x++){
					if( aParadas[x].idParada == aParadas[i].idParada){
						aParadas.splice(x,1);
						--x;
					}
				}
			}
		
		aParadas.sort(functionsGlobals.SortByOrden);	
		pageScheduleSel.showStops(aParadas);
	},

	showStops : function(data) 
	{
		$("#scheduleSel_content").empty();

		$.each(data, function( i, item ) 
		{
			$("#scheduleSel_content").append("<li data-stop="+item.idParada+" data-stopName='"+item.nameParada+"'><p>"+item.idParada+" - "+item.nameParada+"</p></li>");
		});


	},

};

/* EVENTS */

$( document ).off(".scheduleSel")

	.on("pagecreate.scheduleSel", "#page_scheduleSel", function()
	{
		pageScheduleSel.$page = $(this);
	})

	.on("pageshow.scheduleSel", "#page_scheduleSel", function()
	{
		pageScheduleSel.getData();

	})

	.on("click.scheduleSel", "#scheduleSel_content li", function(event)
	{
		event.preventDefault();
		$( "body" ).pagecontainer( "change", "schedule.html?stop="+$(this).attr("data-stop")+"&stopName="+$(this).attr("data-stopName"));
		return false;	
	})

	.on("pageremove.scheduleSel", "#page_scheduleSel", function()
	{
		$( window ).off( ".scheduleSel" );
		$( document ).off(".scheduleSel");
		$( 'link[href="css/pageScheduleSel.css"]' ).remove();
		pageScheduleSel = null;
	});
