var connection = {

	getResponse : function(url, type)
	{
	    var str_url = String.format(url);
	    return serverCall(str_url, type)
	},

	ajax_call : function(theUrl,theFunction, filter)
	{
		functionsGlobals.showLoading();

		$.ajax({
			url: theUrl+filter,
			timeout:60000,  // 60 secs for kicks
			cache: false,
			dataType: "json",
		})
		.success(function(response) {
			if (response) 
			{
				var data = $.xml2json(response);
				eval(theFunction)(data);			
			}
		})
		.error(function(xhRequest, textStatus, errorThrown) {
			functionsGlobals.hideLoading();
			functionsGlobals.showMessage(gjson_lang['error_ajax']);
			connection.ajax_call_fail(xhRequest, textStatus, errorThrown,theFunction);
		});
	},

	ajax_call_fail : function(xhRequest, textStatus, errorThrown,theFunction)
	{
		console.log("Error! Response in console");
		console.error('xhRequest:' + xhRequest);
		console.error('xhr.readyState:' + xhRequest.readyState);
		console.error('xhr.status:' + xhRequest.status);
		console.error('xhr.statusText:' + xhRequest.statusText);
		console.error('xhr.responseText:' + xhRequest.responseText);
		console.error('xhr.responseXML:' + xhRequest.responseXML);
		console.error('xhr.getAllResponseHeaders():' + xhRequest.getAllResponseHeaders());
		console.error('xhr.statusCode():' + xhRequest.statusCode());
		console.error('xhr.abort():' + xhRequest.abort());
		console.error('textStatus:' + textStatus);
		console.error('errorThrown:' + errorThrown);
		console.log(xhRequest)
	} 



};

serverCall = function(url, type) {
	var self = this;

	var promise = $.ajax({
	 				url: url,
					timeout:60000,  // 60 secs for kicks
					cache: false,
					dataType: type,
					type: "GET",
		})
		.error(function(xhRequest, textStatus, errorThrown) {
			functionsGlobals.hideLoading();
			functionsGlobals.showMessage(gjson_lang['error_ajax']);
		});

	return promise;

}

