/* CSS */
$( "body" ).append('<link rel="stylesheet" type="text/css" href="css/pageAllStops.css"/>');

/* VARIABLES */
var pageAllStops = {
		
	$page : null,
	carga_stops: false,


	init: function() 
	{
		pageAllStops.addContent();
		pageAllStops.getData();
	},

	addContent : function() 
	{
		pageAllStops.$page.find("#page_title").text(gjson_lang['page_title_allStops']);
		pageAllStops.$page.find("#myFilter").attr("placeholder",gjson_lang['search_stop']);
	},

	getData : function() 
	{

    	//functionsGlobals.showLoading();
 		
		if (!localStorage.getItem("array_paradas"))
			{
				sessionStorage.setItem("activeFunction", "pageAllStops.getData()");

		       	CallServiceCAI(aConfig["gstr_webServiceURLCAI"], createSoapRequestgetStops(), "functionsGlobals.saveStops");
		       	
			}
		else
		{
			functionsGlobals.carga_paradas = true;
	    	pageAllStops.quitarLoading();
	    	pageAllStops.showStops();
		}

		
	},


	showStops : function() 
	{

    	var aParadas = JSON.parse(localStorage.getItem("array_paradas"));
    	var aParadasAux = [];
    	var aStops = [];

		pageAllStops.$page.find("#all_stops_content").empty();

 	    $.each(aParadas, function(i, item) 
	    {
			if(aParadasAux.indexOf(item.name_parada) == -1)     
				aParadasAux.push(item.name_parada);
	    });   	

 	    aParadasAux.sort();

	    $.each(aParadasAux, function(i, item) 
	    {
		    $.each(aParadas, function(i, item2) 
		    {
				if(item == item2.name_parada)
				{
					aStops.push({
						idParada: item2.id_parada,
						nameParada: item,
						codigoLinea: item2.id_linea,
						latitud: item2.latitud,
						longitud: item2.longitud
					});	
					return false;				
				}
		
		    });
	    });

  	    //$.each(aStops, function(i, item) 
	    for (var i=0, len=aStops.length; i < aStops.length; i++)
	    {
				
				var distance = functionsGlobals.distanceBetweenPoint(sessionStorage.getItem('latitud'),sessionStorage.getItem('longitud'), aStops[i].latitud,aStops[i].longitud);

				if (distance > 999)
				{
					distance = ((distance/1000).toFixed(2)).replace(".", ",");;
					var distance_char = " km";
				}	
				else
					var distance_char = " m";
				

				var pos = i;
				var html = '<li  data-icon = "false" ><a href = "#" data-stop="'+aStops[i].idParada+'"> ' + 
							'<div class = "ui-grid-a">'+
							'<div class="StopName ui-block-a">'+ aStops[i].idParada +" - " +aStops[i].nameParada+ '</div>';
				if (functionsGlobals.geolocation_OK() == true)
					html += '<div class="stopDistance ui-block-b">'+distance+distance_char+'</div>';		
	
					html += '</div></div>'+
							'<div class="stop_list_lines" id="stop'+pos+'">' + 
							'</div>' + 
							'<div class = "div_favorite" id ="favorite'+pos+'"></div>'+
							'<div class="listview_border"></div>'+
							'</li></a>';

				pageAllStops.$page.find("#all_stops_content").append(html);

			$.each( aParadas, function( j, item2 ) 
			{
				if (aStops[i].nameParada == item2.name_parada)
				{
					
					htmlLines = '<div class="line_list_id_list" style="color:'+functionsGlobals.getColorLine(item2.id_linea)+'">'+item2.id_linea+'</div>';	
					pageAllStops.$page.find("#stop"+pos).append(htmlLines);
				}

			});

				if (functionsGlobals.isFavorite(aStops[i].idParada))
				{
					pageAllStops.$page.find("#favorite"+pos).append('<div class = "icon_favorite"><img src="img/stops/lista_favorito.png"></div>');
				}

	    //});
	    }  
		
		pageAllStops.$page.find("#all_stops_content").listview( "refresh" );
		pageAllStops.carga_stops = true;
		pageAllStops.quitarLoading();
	},


	quitarLoading : function() 
	{		
		console.log("quitarLoading");
		if(functionsGlobals.carga_paradas && pageAllStops.carga_stops)
			functionsGlobals.hideLoading();
	}

};

/* EVENTS */

$( document ).off(".allStops")

	.on("pagecreate.allStops", "#page_all_stops", function()
	{
		pageAllStops.$page = $(this);
		functionsGlobals.getLocation();
	})

	.on("pageshow.allStops", "#page_all_stops", function()
	{
		pageAllStops.init();

	})

	.on("click.allStops", "#page_all_stops #all_stops_content a", function(event)
	{
		event.preventDefault();
		$( "body" ).pagecontainer( "change", "StopTimes.html?stop=" + $(this).attr("data-stop")+"&sentido_linea="+pageAllStops.sentido_linea );
		return false
	})

	.on("click.allStops", "#page_all_stops #btn_filtro", function(event)
  	{
	   	event.preventDefault(); 
	    if(pageAllStops.$page.find(".div_search").is(":visible"))
	    {
			pageAllStops.$page.find(".div_search").hide();
			pageAllStops.$page.find(".ui-footer").show();
			$("#all_stops_content").css("padding-top", "0");

			if(device_platform == "IOS")
	    	{
		        $("#app_header").css("position", "fixed");
		        $(".div_search").css("position", "fixed");
	    	}

	      	$('#myFilter').blur();
	    }
	    else
	    {
	    	// BUGFIX HEADER & KEYBOARD SHOWED
	    	if(device_platform == "IOS")
	        {
	            $("#app_header").css("position", "absolute");
	            $(".div_search").css("position", "absolute");
	        }


	      $(".ui-footer").hide();
	      pageAllStops.$page.find(".div_search").show();
	      $("#all_stops_content").css("padding-top", "4em");
	      $('#myFilter').focus();

	      setTimeout(function(){
	        $(".ui-footer").show();
	      }, 1000);

	    }
	    return false;
  	})	

	.on("pageremove.allStops", "#page_all_stops", function()
	{
		$( window ).off( ".allStops" );
		$( document ).off(".allStops");
		$( 'link[href="css/pageAllStops.css"]' ).remove();
		pageAllStops = null;
	});


