/* CSS */
$( "body" ).append('<link rel="stylesheet" type="text/css" href="css/pageFavorites.css"/>');

/* VARIABLES */
var pageFavorites = {
		
	$page : null,
	actual_line : 'regular',
	carga_lineas : false,
	carga_paradas : false,

	init: function() 
	{
		pageFavorites.addContent();
	},

	addContent : function() 
	{
		pageFavorites.$page.find("#page_title").text(gjson_lang['page_title_favorites']);

		var aFavorites = JSON.parse(localStorage.getItem("array_favorites")) || [];;
		if (aFavorites.length == 0)
			functionsGlobals.showMessage(gjson_lang['no_favorites_list'], "");
		else
			pageFavorites.getData(JSON.parse(localStorage.getItem("array_favorites")));
	},

	getData : function(data) 
	{
		var dataAUX = [];
		var aFavorites = [];

	    $.each(data, function(i, item) 
	    {
			if(dataAUX.indexOf(item.id_parada) == -1)     
				dataAUX.push(item.id_parada);
	    });

	    $.each(dataAUX, function(i, item) 
	    {
		    $.each(data, function(i, item2) 
		    {
				if(item == item2.id_parada)
				{
					aFavorites.push({
						id_parada: item,
						name_parada: item2.name_parada,
						id_linea: item2.id_linea,
						longitud: item2.longitud,
						latitud: item2.latitud,
					});	
					return false;				
				}
		
		    });
	    });


		pageFavorites.$page.find("#favorites_content").empty();
		$.each( aFavorites, function( i, item ) 
		{
			pos = i;
			var distance = functionsGlobals.distanceBetweenPoint(sessionStorage.getItem('latitud'),sessionStorage.getItem('longitud'), item.latitud,item.longitud);

				if (distance > 999)
				{
					distance = ((distance/1000).toFixed(2)).replace(".", ",");;
					var distance_char = " km";
				}	
				else
					var distance_char = " m";
				

				var html = '<li data-icon = "false"><a href = "#" data-stop="'+item.id_parada+'"> ' + 
							'<div class="ui-grid-a">' +
							'<div class="ui-block-a">'+ item.id_parada +" - " +item.name_parada+ '</div>';
					
				if (functionsGlobals.geolocation_OK() == true)		
					html += '<div class="stopDistance ui-block-b">'+distance+distance_char+'</div>';

				html += '</div></div>' + 
						'<div class="stop_pos" id="stop'+pos+'"></div>' + 
						'<div id="stopF'+i+'" class="div_favorite"></div>' +
						'</li></a>';

				pageFavorites.$page.find("#favorites_content").append(html);
				pageFavorites.$page.find("#favorites_content").listview( "refresh" );

			$.each( data, function( i, item2 ) 
			{
				if (item.id_parada == item2.id_parada)
				{
					
					htmlLines = '<div class="stopline-list-div" style="color:'+functionsGlobals.getColorLine(item2.id_linea)+'">'+item2.id_linea+'</div>';	
					pageFavorites.$page.find("#stop"+pos).append(htmlLines);
				}

				
				
			});
			
			if (functionsGlobals.isFavorite(item.id_parada))
				pageFavorites.$page.find("#stopF"+pos).append('<div class = "icon_favorite"><img src="img/stops/lista_favorito.png"></div>');
		});

		functionsGlobals.hideLoading();
		
	}

};

/* EVENTS */

$( document ).off(".favorites")

	.on("pagecreate.favorites", "#page_favorites", function()
	{
		pageFavorites.$page = $(this);
	})

	.on("pageshow.favorites", "#page_favorites", function()
	{
		functionsGlobals.getLocation();
		pageFavorites.init();
	})

	.on("click.favorites", "#favorites_content a", function(event)
	{
		event.preventDefault();
		$( "body" ).pagecontainer( "change", "StopTimes.html?stop=" + $(this).attr("data-stop"));
		return false;	
	})

	.on("pageremove.favorites", "#page_favorites", function()
	{
		$( window ).off( ".favorites" );
		$( document ).off(".favorites");
		$( 'link[href="css/pageFavorites.css"]' ).remove();
		pageFavorites = null;
	});