/* CSS */
$( "body" ).append('<link rel="stylesheet" type="text/css" href="css/pageHome.css"/>');

/* VARIABLES */
var pageHome = {
    
    $page : null,
    
init: function() {
    
    thisLang = localStorage.getItem("language");
    if (thisLang && (thisLang == "es" || thisLang == "eu" || thisLang == "en" ))
        $( "body" ).pagecontainer( "change", "lines.html" );
    else
        pageHome.$page.find( ".div_home_buttons").show();
},
    
    deleteStops : function()
    {
        
        if(!localStorage.getItem("localUpdate"))
        {
            milisegundos=parseInt(35*24*60*60*1000);
            fecha=new Date();
            dia=fecha.getDate();
            mes=fecha.getMonth()+1;
            anio=fecha.getYear();
            tiempo=fecha.getTime();
            total=fecha.setTime(parseInt(tiempo+milisegundos));
            localStorage.setItem("localUpdate", total);
        }
        
        
        
        milisegundos=parseInt(35*24*60*60*1000);
        fecha=new Date();
        dia=fecha.getDate()+1;
        mes=fecha.getMonth()+1;
        anio=fecha.getYear();
        tiempo=fecha.getTime();
        total2=fecha.setTime(parseInt(tiempo+milisegundos));
        
        if (localStorage.getItem("array_lineas"))
        {
            var aLineas = JSON.parse(localStorage.getItem("array_lineas"));
            
            if (total2-localStorage.getItem("localUpdate") > aConfig["update_rate"])
            {
                localStorage.removeItem("array_lineas");
                localStorage.removeItem("array_paradas");
                
                for (var i=1, len=(aLineas.length+1)*2; i < (aLineas.length+1)*2; i++)
                {
                    localStorage.removeItem("array_lineasParadas"+i);
                }
                
                localStorage.setItem("localUpdate", total2);
            }
        }
    },
    
};

/* EVENTS */

$( document ).off(".home")

.on("pagecreate.home", "#page_home", function()
    {
    pageHome.$page = $(this);
    pageHome.deleteStops();
    })

.on("pageshow.home", "#page_home", function()
    {
    pageHome.$page.find( ".div_home_buttons").hide();
    pageHome.init();
    })

.on("click.home", "#page_home .btn_language", function(event)
    {
    event.preventDefault();
    language = $(this).attr("data-lang");
    localStorage.setItem("language",$(this).attr("data-lang"));
    
    window.location.href = "lines.html";
    
    //$( "body" ).pagecontainer( "change", "NextToMe.html" );
    })

.on("pageremove.home", "#page_home", function()
    {
    $( window ).off( ".home" );
    $( document ).off(".home");
    $( 'link[href="css/pageHome.css"]' ).remove();
    pageHome = null;
    });

