/* CSS */
$( "body" ).append('<link rel="stylesheet" type="text/css" href="css/pagePushNews2.css"/>');

/* VARIABLES */
var pagePushNews2 = {
		
	$page : null,
	active_tab : 4,


	init: function() 
	{
		pagePushNews2.getData();
		//pagePushNews2.getData();
	},

	getData : function() 
	{

		functionsGlobals.showLoading();

		if ( functionsGlobals.getURLParameter("line") == "00")
		{
			pagePushNews2.$page.find("#page_title").text(gjson_lang.page_title_notifications+" "+gjson_lang.all_lines);
			var URL_PUSH_RSS_NEWS = aConfig["URL_RSS_NEWS_"+language];
		}
		else
		{
			pagePushNews2.$page.find("#page_title").text(gjson_lang.page_title_notifications+" "+gjson_lang.line+" "+functionsGlobals.getURLParameter("line"));
			var URL_PUSH_RSS_NEWS = aConfig["URL_LINE_RSS_NEWS_"+language]+functionsGlobals.getURLParameter("line");
		}
			

		//if ( gb_isCordovaLoaded == true && functionsGlobals.comprobarConexion() )
    	//{
	         	connection.getResponse(URL_PUSH_RSS_NEWS, "xml")
	            .done(function(data_response) {
	                      pagePushNews2.showData(data_response);
	            });       		
		//}

		
	},

	showData : function(data) 
	{

		pagePushNews2.$page.find("#page-push-news-list").empty();
		html = '<li data-icon="false"><p>'+gjson_lang['no_datos']+'</p></li>';
		pagePushNews2.$page.find("#page-push-news-list").append(html);

		$(data).find(' channel item ').each(function(i)
		{
			if (i == 0)
			{
				pagePushNews2.$page.find("#page-push-news-list").empty();
				html = '<a data-rel = "external" href = "'+$(this).find('link').text()+'">'+
						'<li data-icon="false">'+ 
						'<p class = "news_date">'+ functionsGlobals.getDateFormatted($(this).find('pubDate').text()) + '</p>'+
						'<h1>'+ $(this).find('title').text() + '</h1>'+
						'<p>'+ $(this).find('description').text()+ '</p>'+
						'</li></a>';	
			}		
			else	
				html = '<a data-rel = "external" href = "'+$(this).find('link').text()+'">'+
						'<li data-icon="false">'+ 
						'<p class = "news_date">'+ functionsGlobals.getDateFormatted($(this).find('pubDate').text()) + '</p>'+
						'<h1>'+ $(this).find('title').text() + '</h1>'+
						'<p>'+ $(this).find('description').text()+ '</p>'+
						'</li></a>';				

			pagePushNews2.$page.find("#page-push-news-list").append(html);

		});

		pagePushNews2.$page.find('#page-push-news-list').listview('refresh');
		functionsGlobals.hideLoading();

		var Notifications = JSON.parse(localStorage.getItem("BilbobusPush")) || [];

				for( var x = 0; x < Notifications.length; x++){
					if( Notifications[x].push_id == functionsGlobals.getURLParameter("push_id")){
						Notifications.splice(x,1);
						--x;
					}
				}

		localStorage.setItem("BilbobusPush", JSON.stringify(Notifications));
	}

};

/* EVENTS */

$( document ).off(".pushNews2")

	.on("pagecreate.pushNews2", "#page_pushNews2", function()
	{
		pagePushNews2.$page = $(this);
	})

	.on("pageshow.pushNews2", "#page_pushNews2", function()
	{
		pagePushNews2.init();
		localStorage.removeItem("external_push");

	})
		
	.on("pageremove.pushNews2", "#page_pushNews2", function()
	{
		$( window ).off( ".pushNews2" );
		$( document ).off(".pushNews2");
		$( 'link[href="css/pagePushNews2.css"]' ).remove();
		pagePushNews2 = null;
	});
