/* CSS */
$( "body" ).append('<link rel="stylesheet" type="text/css" href="css/pageRules.css"/>');

/* VARIABLES */
var pageRules = {
		
	$page : null,

	init: function() 
	{
		
		pageRules.addContent();
		pageRules.getData();

	},

	addContent : function() 
	{
		pageRules.$page.find("#page_title").text(gjson_lang['page_title_rules']);
	},

	getData : function() 
	{

    	functionsGlobals.showLoading();
    	  	 
        connection.getResponse(aConfig["URL_JSON_RULES"], "json")
            .done(function(data_response) {
                      pageRules.showData(data_response);
            });
	},

	showData : function(data) 
	{
		pageRules.$page.find("#div_pageRules").empty().html(eval("data.content_"+language));
		functionsGlobals.hideLoading();
	}

};

/* EVENTS */

$( document ).off(".rules")

	.on("pagecreate.rules", "#page_rules", function()
	{
		pageRules.$page = $(this);
	})

	.on("pageshow.rules", "#page_rules", function()
	{
		pageRules.init();
	})

	.on("pageremove.rules", "#page_rules", function()
	{
		$( window ).off( ".rules" );
		$( document ).off(".rules");
		$( 'link[href="css/pageRules.css"]' ).remove();
		pageRules = null;
	});

